;* ------------------------------------------------------- *
;Beispiel zur DMA-Programmierung

DMA equ 0

;Programmierung von Kanal 0

;Adresse umwandeln (1. Mglichkeit)

     MOV BX, 16
     MOV AX, DS     ;Segmentadresse nach AX
     MUL BX         ;mit 16 multiplizieren

;Ergebnis steht als 32-Bit Wert in DX:AX

     ADD AX, SI     ;Offset addieren
     ADC DX, 0      ;evtl. Carry-bertrag addieren

;Low-Byte der Quell-Adresse zum 8237 schreiben

     OUT DMA, AL

;High-Byte der Quell-Adresse zum 8237 schreiben

     MOV AL, AH
     OUT DMA, AL

;Pageregister 0 schreiben

     OUT DMA, DL

;Low-Byte der Blocklnge zum Blocklngenregister 0 schreiben

     MOV AL, CL
     OUT DMA+1, AL

;Hi-Byte der Blocklnge zum Blocklngenregister 0 schreiben

     MOV AL, CH
     OUT DMA+1, AL

;Betriebsartenregister fr Kanal 0 schreiben

     MOV AL, 10001000b

;Blockbetrieb, Speicheradresse erhhen,
; kein autom. wiederholen
;Speicher lesen, Kanal 0

     OUT 1011b, AL

;Programmierung von Kanal 1
;Adresse umwandeln (ist schneller als 1. Mglichkkeit)

     MOV AX, ES     ;Segmentanteil nach AX
     MOV CL, 4
     ROL AX, CL     ;AX um 4 Bits nach links rotieren

;dadurch stehen die 4 hchstwertigen Bits ganz rechts

     MOV CH, AL     ;4 Bits retten und maskieren
     AND CH, 00001111b
     AND AL, 11110000b
     ADD AX, DI     ;Offset addieren
     ADD CH,0       ;evtl. Carry-bertrag addieren

;Low-Byte der Zieladresse zum 8237 schreiben

     OUT DMA, AL

;Hi-Byte der Zieladresse zum 8237 schreiben

     MOV AL, AH
     OUT DMA, AL

;Pageregister 1 schreiben

     OUT DMA+1, CH

;Low-Byte der Blocklnge zum Blocklngenregister 1 schreiben

     MOV AL, CL
     OUT DMA+1, AL

;Hi-Byte der Blocklnge zum Blocklngenregister 1 schreiben

     MOV AL, CH
     OUT DMA+1, AL

;Betriebsartenregister fr Kanal 1 schreiben

     MOV AL, 10000101b

;Blockbetrieb, Speicheradresse erhhen, kein automatisches
;wiederholen, Speicher schreiben, Kanal 1

     OUT 1011b, AL
;* ------------------------------------------------------- *
